#set working directory to the project folder
#setwd("")

traitdata<-read.csv(file="data/MERGED traits.csv", header=TRUE, sep = ";")
da3 = read.csv(file="data/meantemp.csv", header=TRUE, sep = ",")
alldata<-read.csv(file="data/MERGED pa.csv", header=TRUE, sep = ";")
tr = traitdata$Non.adult.feeding
ns = length(tr)
trs = levels(tr)
trs = setdiff(trs,"Omnivorous")
ntrs = length(trs)
pdf("results/trends_richness.pdf",width = 8,height = 5)
par(mfrow=c(2,3))
for (group in 1:(ntrs+2)){
  if(group<3){
    selsp = 1:ns
    groupname = "All species"
  } else {
    selsp = tr==trs[group-2]
    groupname = trs[group-2]
  }  
  Spdata<-alldata[,-c(1:4)]
  Richness<-rowSums(Spdata[,selsp])
  Richnessyeartrap<-data.frame(cbind(alldata$trap, alldata$year, alldata$week, Richness))
  
  colnames(Richnessyeartrap) = c("trap","year","week","Richness")
  Richnessyeartrap[, 1:1] <- sapply(Richnessyeartrap[, 1:1], as.factor)
  Richnessyeartrap[, 2:4] <- sapply(Richnessyeartrap[, 2:4], as.numeric)
  head(Richnessyeartrap)
  
  mi = min(Richnessyeartrap$week)-1
  ma = max(Richnessyeartrap$week)+1
  #mi = 1
  #ma = 52
  me = mean(c(mi,ma))
  
  Richnessyeartrap$time = Richnessyeartrap$year + (Richnessyeartrap$week-me)/(ma-mi)
  years = unique(Richnessyeartrap$year)
  times = c()
  for (year in years){
    for (week in mi:ma){
      times = c(times,year+(week-me)/(ma-mi))
    }
  }
  nt = length(times)
  S = rep(NA,nt)
  ny = length(years)
  S2 = rep(0,ny)
  S2count = rep(0,ny)
  for(i in 1:nt){
    S[i] = mean(Richnessyeartrap[Richnessyeartrap$time==times[i],]$Richness)
  }
  if(group==1){
    S=c()
    for (i in 1:ny){
      year = years[i]
      for (week in mi:ma){
        sel = (da3$Week==week & da3$Year==year)
        if(sum(sel)==1){
          val = da3[sel,]$airTemp
          if(year==2009 & week==ma){val=NA}
          S = c(S,val)
          if(!is.na(val)){
            S2[i] = S2[i] + val
            S2count[i] = S2count[i] + 1
          }
        }
      }
      S2[i] = S2[i]/S2count[i]
    }
    S2SR = S2
    SSR = S
  }
  if(group>1){
    for(i in 1:ny){
      S2[i] = mean(Richnessyeartrap[Richnessyeartrap$year==years[i],]$Richness)
    }
  }
  mylm=lm(S2~years)
  su=summary(mylm)
  pval = su$coefficients[2,4]
  mylm1 = arima(S2, xreg = years)
  mylm0 = arima(S2)
  deltaAIC = mylm0$aic-mylm1$aic
  par(mar = c(4.1, 4.1, 3.1, 1.1)) 
  plot(times,S,type = "l",
       main = paste0(if(group==1){"Temperature"}else{groupname},
                     " (p = ",as.character(round(pval,3)),
                     ", deltaAIC = ",as.character(round(deltaAIC,1)),")"),
       cex.main=0.9,
       xlab="",ylab=if(group==1){"Temperature"}else{"Species richness"},xaxt='n')
  axis(1, at=min(years):max(years),las=2)
  mtext(c("(a)","(b)","(c)","(d)","(e)","(f)")[group], side = 3, adj = -0.2, line = 0.8)
      
  points(years,S2,col="red",pch=19)
  lines(years,S2,col="red")
  lines(years,fitted.values(mylm),col="blue")
}
dev.off()
S2 = S2SR
S = SSR
save(S,times,S2,years,file="results/temperature patterns")


