#set working directory to the project folder
#setwd("")

alldata<-read.csv(file="data/MERGED pa.csv", header=TRUE, sep = ";")
traitdata<-read.csv(file="data/MERGED traits.csv", header=TRUE, sep = ";")
da3 = read.csv(file="data/meantemp.csv", header=TRUE, sep = ",")

tr = traitdata$Family
ns = length(tr)
trs = sort(table(tr),decreasing = TRUE) 
trs = c(names(trs[1:3]),"Other")
ntrs = length(trs)
#pdf("results/trends_richness_families.pdf",width = 6,height = 5)
tiff("results/trends_richness_families.tiff",width=6,height=5,units="in",res=300)  
par(mfrow=c(2,2))
for (group in 1:ntrs){
  if(group==4){
    selsp = (tr!=trs[1]) & (tr!=trs[2]) & (tr!=trs[3])
  } else {
    selsp = tr==trs[group]
  }  
  groupname = trs[group]
  Spdata<-alldata[,-c(1:4)]
  Richness<-rowSums(Spdata[,selsp])
  Richnessyeartrap<-data.frame(cbind(alldata$trap, alldata$year, alldata$week, Richness))
  
  colnames(Richnessyeartrap) = c("trap","year","week","Richness")
  Richnessyeartrap[, 1:1] <- sapply(Richnessyeartrap[, 1:1], as.factor)
  Richnessyeartrap[, 2:4] <- sapply(Richnessyeartrap[, 2:4], as.numeric)
  head(Richnessyeartrap)
  
  mi = min(Richnessyeartrap$week)-1
  ma = max(Richnessyeartrap$week)+1
  #mi = 1
  #ma = 52
  me = mean(c(mi,ma))
  
  Richnessyeartrap$time = Richnessyeartrap$year + (Richnessyeartrap$week-me)/(ma-mi)
  years = unique(Richnessyeartrap$year)
  times = c()
  for (year in years){
    for (week in mi:ma){
      times = c(times,year+(week-me)/(ma-mi))
    }
  }
  nt = length(times)
  S = rep(NA,nt)
  ny = length(years)
  S2 = rep(0,ny)
  S2count = rep(0,ny)
  for(i in 1:nt){
    S[i] = mean(Richnessyeartrap[Richnessyeartrap$time==times[i],]$Richness)
  }
    for(i in 1:ny){
      S2[i] = mean(Richnessyeartrap[Richnessyeartrap$year==years[i],]$Richness)
    }
  mylm=lm(S2~years)
  su=summary(mylm)
  pval = su$coefficients[2,4]
  mylm1 = arima(S2, xreg = years)
  mylm0 = arima(S2)
  deltaAIC = mylm0$aic-mylm1$aic
  par(mar = c(4.1, 4.1, 3.1, 1.1)) 
  plot(times,S,type = "l",
       main = paste0(groupname,
                     " (p = ",as.character(round(pval,3)),
                     ", deltaAIC = ",as.character(round(deltaAIC,1)),")"),cex.main=0.8,
       xlab="",ylab="Species richness",xaxt='n')
  axis(1, at=min(years):max(years),las=2)
      
  points(years,S2,col="red",pch=19)
  lines(years,S2,col="red")
  lines(years,fitted.values(mylm),col="blue")
}
dev.off()

