library(Hmsc)
set.seed(1)

#set working directory to the project folder
#setwd("")

localDir = "."
data.directory = file.path(localDir, "data")
model.directory = file.path(localDir, "models")

nChains = 2
samples = 1000
thin = 100
tiff("results/MCMC convergence.tiff",width=8,height=5,units="in",res=300)
climtype = 1
abutype = 1
par(mfrow=c(2,2))
for (i in c(1,2,3,7)){
  filename=file.path(model.directory, paste0("model_",as.character(i),
                                             "_climtype_",as.character(climtype),
                                             "_abutype_",as.character(abutype),
                                             "_chains_",as.character(nChains),
                                             "_samples_",as.character(samples),
                                             "_thin_",as.character(thin)))
  load(filename)
  mpost = convertToCodaObject(m,Gamma = FALSE, V = FALSE, Sigma = FALSE,
                              Rho = FALSE, Eta = FALSE, Lambda = FALSE,
                              Alpha = FALSE, Omega = FALSE, Psi = FALSE, Delta = FALSE)
  psrf = gelman.diag(mpost$Beta,multivariate = FALSE)$psrf
  psrf = psrf[!is.na(psrf)]
  if(i<10){
    hist(psrf,main=c("Abiotic model","Density-dependent model","Trophic-interactions model","","","","Species-interactions model")[i],xlab = "psrf")
  } else {
    hist(psrf,main=c("Abiotic","Density-dependent","Trophic interactions","Species interactions")[i],xlab = "psrf",breaks = 500,xlim=c(0.9,2))
  }
}
dev.off()
