library(Hmsc)
set.seed(1)
#set working directory to the project folder
#setwd("")

localDir = "."
data.directory = file.path(localDir, "data")
model.directory = file.path(localDir, "models")
model.fit.directory = file.path(localDir, "model fits")

nChains = 2
samples = 1000
thin = 10
i = 1
climtype = 1
abutype = 1
filename=file.path(model.directory, paste0("model_",as.character(i),
                                           "_climtype_",as.character(climtype),
                                           "_abutype_",as.character(abutype),
                                           "_chains_",as.character(nChains),
                                           "_samples_",as.character(samples),
                                           "_thin_",as.character(thin)))
load(filename)
partition = createPartition(m, nfolds = length(levels(m$studyDesign$year)),
                            column = "year")
samples = 1000
climtype = 2 #1: summer; 2: winter
abutype = 3 #1: pa; 2: DNA-abu conditional; 3: DNA-abu total
set.seed(13)
for(thin in c(1,10)){
  for (i in 7){
    filename=file.path(model.directory, paste0("model_",as.character(i),
                                               "_climtype_",as.character(climtype),
                                               "_abutype_",as.character(abutype),
                                               "_chains_",as.character(nChains),
                                               "_samples_",as.character(samples),
                                               "_thin_",as.character(thin)))
    load(filename)
    preds = computePredictedValues(m)
    mpred = apply(preds,MARGIN = c(1,2),FUN=mean)
    MF = evaluateModelFit(hM=m, predY=preds)   
    
    preds = computePredictedValues(m,partition=partition, nParallel = nChains)
    mpredCV = apply(preds,MARGIN = c(1,2),FUN=mean)
    MFCV = evaluateModelFit(hM=m, predY=preds)
    WAIC = computeWAIC(m)
    filename=file.path(model.fit.directory, paste0("mf_model_",as.character(i),
                                               "_climtype_",as.character(climtype),
                                               "_abutype_",as.character(abutype),
                                               "_chains_",as.character(nChains),
                                               "_samples_",as.character(samples),
                                               "_thin_",as.character(thin)))
    save(partition,MF,MFCV,WAIC,mpred,mpredCV,file=filename)
  }
}
